#define _XOPEN_SOURCE 500
#define _GNU_SOURCE
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/mman.h>

#define MMAP_THREADS 4

void map_file(int fd)
{
	char *addr = mmap(NULL, 4096, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
	int i;

	if (addr == MAP_FAILED) {
		perror("mmap");
		exit(1);
	}
	while (1) {
		for (i = 0; i < 128; i++)
			addr[i + 1024] = 'c';
	}
}

char buf2[4096] __attribute__ ((aligned (4096)));

int main(int argc, char **argv)
{
	int i;
	int ret;
	int fd;
	char buf[1024];

	if (argc != 2) {
		printf("Usage: test-mkwrite <file>\n");
		return 1;
	}
	fd = open(argv[1], O_RDWR | O_CREAT | O_TRUNC, 0644);
	if (fd < 0) {
		perror("open");
		return 1;
	}
	memset(buf, 'a', sizeof(buf));
	pwrite(fd, buf, sizeof(buf), 0);

	for (i = 0; i < MMAP_THREADS; i++) {
		ret = fork();
		if (ret < 0) {
			perror("fork");
			return 1;
		} else if (ret == 0)
			map_file(fd);
	}
	close(fd);

	memset(buf2, 'b', sizeof(buf2));
	fd = open(argv[1], O_RDWR | O_DIRECT);
	if (fd < 0) {
		perror("dopen");
		return 1;
	}
	while (1) {
		if (pwrite(fd, buf2, 4096, 4096) < 0)
			perror("pwrite");
		usleep(10000000);
		ftruncate(fd, 1024);
		usleep(10000000);
	}
	
	return 0;
}
